<?php

$code = (string)$_GET['code'];
$x = (float)$_GET['x'];
$y = (float)$_GET['y'];
$size = (float)$_GET['size'];
$imgFormat = (string)$_GET['imgFormat'];

$error_level = (string)$_GET['error_level'];
$aspect_ratio = (float)$_GET['aspect_ratio'];
$size_kind = (string)$_GET['size_kind'];
if($size_kind == "COL_NUM" || $size_kind == "COL_NUM_AND_ROW_NUM")
	$cols = (int)$_GET['cols'];
if($size_kind == "ROW_NUM" || $size_kind == "COL_NUM_AND_ROW_NUM")
	$rows = (int)$_GET['rows'];


require_once("barcode.php/Pdf417.php");

// バーコード描画 (PNGファイル)
$barcode = new Pdf417();

// encoding(option / default:utf-8)
$barcode->StringEncoding = (string)$_GET['encoding'];

if($error_level == "AUTO")
{
	$barcode->UseAutoErrorLevel = true;
}
else
{
	$barcode->UseAutoErrorLevel = false;
	$barcode->ErrorLevel = (float)$_GET['error_level'];
}

$barcode->AspectRatio = $aspect_ratio;

if($size_kind == "AUTO")
{
	$barcode->SizeKind = Pdf417::SIZE_KIND_AUTO;
}
else if($size_kind == "COL_NUM")
{
	$barcode->SizeKind = Pdf417::SIZE_KIND_COLUMNS;
	$barcode->CodeColumns = $cols;
}
else if($size_kind == "ROW_NUM")
{
	$barcode->SizeKind = Pdf417::SIZE_KIND_ROWS;
	$barcode->CodeRows = $rows;
}
else if($size_kind == "COL_NUM_AND_ROW_NUM")
{
	$barcode->SizeKind = Pdf417::SIZE_KIND_COLUMNS_AND_ROWS;
	$barcode->CodeColumns = $cols;
	$barcode->CodeRows = $rows;
}

$img = $barcode->draw($code, $size);

$fileName = "gazou/gazou.png";
if($imgFormat == "png")
{
	$fileName = "gazou/gazou.png";
	ImagePNG($img, $fileName);
}
else if($imgFormat == "jpeg")
{
	$fileName = "gazou/gazou.jpg";
	ImageJPEG($img, $fileName);
}
else if($imgFormat == "gif")
{
	$fileName = "gazou/gazou.gif";
	ImageGIF($img, $fileName);
}


$size = GetImageSize($fileName);
print("<html>\n");
print("<head>\n");
print("<title>PDF417 Code Test Output</title>\n");
print("</head>\n");
print("<body>\n");

print("<DIV id=\"PDF417\" style=\"position : absolute;width : ".$size[0]."px;height : ".$size[1]."px;z-index : 1;visibility : visible;left : ".$x."px;top : ".$y."px;\">\n"
	."<IMG src=\"".$fileName."?".rand()."\" width=".$size[0]." height=".$size[1]." border=\"0\"></DIV>\n");

print("</body>\n");
print("</html>\n");
