<?php

$kind = (string)$_GET['kind'];
$code = (string)$_GET['code'];
$x = (float)$_GET['x'];
$y = (float)$_GET['y'];
$minWidthDot = (float)$_GET['minWidthDot'];
$height = (float)$_GET['height'];
if(isset($_GET['dispStartStopCode'])){
	$dispStartStopCode = (bool)$_GET['dispStartStopCode'];
}
$rotateAngle = (int)$_GET['rotateAngle'];
$imgFormat = (string)$_GET['imgFormat'];
if(isset($_GET['typeDatabar14'])){
	$typeDatabar14 = (string)$_GET['typeDatabar14'];
}
if(isset($_GET['typeDatabarExpanded'])){
	$typeDatabarEx = (string)$_GET['typeDatabarExpanded'];
}
if(isset($_GET['CodeSet128'])){
	$CodeSet128 = (string)$_GET['CodeSet128'];
}

require_once("barcode.php/Code39.php");
require_once("barcode.php/Code93.php");
require_once("barcode.php/Code128.php");
require_once("barcode.php/EAN128.php");
require_once("barcode.php/Databar14.php");
require_once("barcode.php/DatabarLimited.php");
require_once("barcode.php/DatabarExpanded.php");
require_once("barcode.php/ITF.php");
require_once("barcode.php/Jan8.php");
require_once("barcode.php/Jan13.php");
require_once("barcode.php/UpcA.php");
require_once("barcode.php/UpcE.php");
require_once("barcode.php/Matrix2of5.php");
require_once("barcode.php/NEC2of5.php");
require_once("barcode.php/NW7.php");
require_once("barcode.php/QR.php");
require_once("barcode.php/YubinCustomer.php");
$barcode = null;
$qr = null;

$arrEsc = array(
	"《NUL》" => "\x00",
	"《SOH》" => "\x01",
	"《STX》" => "\x02",
	"《ETX》" => "\x03",
	"《EOT》" => "\x04",
	"《ENQ》" => "\x05",
	"《ACK》" => "\x06",
	"《BEL》" => "\x07",
	"《BS》" => "\x08",
	"《HT》" => "\x09",
	"《LF》" => "\x0A",
	"《VT》" => "\x0B",
	"《FF》" => "\x0C",
	"《CR》" => "\x0D",
	"《SO》" => "\x0E",
	"《SI》" => "\x0F",
	"《DLE》" => "\x10",
	"《DC1》" => "\x11",
	"《DC2》" => "\x12",
	"《DC3》" => "\x13",
	"《DC4》" => "\x14",
	"《NAK》" => "\x15",
	"《SYN》" => "\x16",
	"《ETB》" => "\x17",
	"《CAN》" => "\x18",
	"《EM》" => "\x19",
	"《SUB》" => "\x1A",
	"《ESC》" => "\x1B",
	"《FS》" => "\x1C",
	"《GS》" => "\x1D",
	"《RS》" => "\x1E",
	"《US》" => "\x1F",
	"《DEL》" => "\x7F",
);

switch ($kind)
{
	case "code39":
		$barcode = new Code39();
		$barcode->dispStartStopCode = $dispStartStopCode;
		break;
	case "code93":
		$barcode = new Code93();
		break;
	case "code128":
		$barcode = new Code128();
		if(!isset($_GET['CodeSet128'])){
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		elseif($CodeSet128 == "")
		{
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		elseif ($CodeSet128 == "A")
		{
			$barcode->CodeABC = CodeSet128::CODE_A;
		}
		elseif ($CodeSet128 == "B")
		{
			$barcode->CodeABC = CodeSet128::CODE_B;
		}
		elseif ($CodeSet128 == "C")
		{
			$barcode->CodeABC = CodeSet128::CODE_C;
		}
		else
		{
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		break;
	case "gs1-128":
		$barcode = new GS1_128();
		if($CodeSet128 == "")
		{
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		elseif ($CodeSet128 == "A")
		{
			$barcode->CodeABC = CodeSet128::CODE_A;
		}
		elseif ($CodeSet128 == "B")
		{
			$barcode->CodeABC = CodeSet128::CODE_B;
		}
		elseif ($CodeSet128 == "C")
		{
			$barcode->CodeABC = CodeSet128::CODE_C;
		}
		else
		{
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		break;
	case "gs1-Databar-14":
		$barcode = new Databar14();
		if($typeDatabar14 == "Omni-directional")
		{
			// GS1 Databar (RSS) 標準型
			$barcode->symbolType = Databar14::OMNIDIRECTIONAL;
		}
		elseif ($typeDatabar14 == "Stacked")
		{
			// GS1 Databar (RSS) 二層型
			$barcode->symbolType = Databar14::STACKED;
		}
		else
		{
			// GS1 Databar (RSS) 標準二層型
			$barcode->symbolType = Databar14::STACKED_OMNIDIRECTIONAL;
		}
		break;
	case "gs1-Databar-Limited":
		// GS1 Databar (RSS) 限定型
		$barcode = new DatabarLimited();
		break;
	case "gs1-Databar-Expanded":
		$barcode = new DatabarExpanded();
		if($typeDatabarEx == "UnStacked")
		{
			// GS1 Databar (RSS) 拡張型(一層)
			$barcode->symbolType = DatabarExpanded::UNSTACKED;
		}
		else
		{
			// GS1 Databar (RSS) 拡張多層型
			$barcode->symbolType = DatabarExpanded::STACKED;
		}
		break;
	case "itf":
		$barcode = new ITF();
		break;
	case "jan8":
		$barcode = new Jan8();
		break;
	case "jan13":
		$barcode = new Jan13();
		break;
	case "UPC-A":
		$barcode = new UpcA();
		break;
	case "UPC-E":
		$barcode = new UpcE();
		break;
	case "matrix2of5":
		$barcode = new Matrix2of5();
		break;
	case "nec2of5":
		$barcode = new NEC2of5();
		break;
	case "nw7":
		$barcode = new NW7();
		$barcode->dispStartStopCode = $dispStartStopCode;
		break;
	default :
		print("Nothing Barcode !!\n");
		break;
}


if(strpos($code,"《") !== false && strpos($code,"》") !== false){

	$pattern = '/《.+?》/';
	preg_match_all($pattern, $code, $match);
	for($i=0; $i <  count($match[0]); $i++)
	{
		$code = str_replace($match[0][$i], $arrEsc[$match[0][$i]], $code);
	}
	$barcode->TextWrite = false;
}




// バーコード描画 (PNGファイル)
$img = $barcode->draw($code, $minWidthDot, $height);

// 回転
if($rotateAngle != 0) {
	$img = imagerotate($img, $rotateAngle, 0);
}

$fileName = "gazou/gazou.png";
if($imgFormat == "png")
{
	$fileName = "gazou/gazou.png";
	ImagePNG($img, $fileName);
}
else if($imgFormat == "jpeg")
{
	$fileName = "gazou/gazou.jpg";
	ImageJPEG($img, $fileName);
}
else if($imgFormat == "gif")
{
	$fileName = "gazou/gazou.gif";
	ImageGIF($img, $fileName);
}



$size = GetImageSize($fileName);
print("<html>\n");
print("<head>\n");
print("<title>Barcode Test Output</title>\n");
print("</head>\n");
print("<body>\n");

print("<DIV id=\"Barcode\" style=\"position : absolute;width : ".$size[0]."px;height : ".$size[1]."px;z-index : 1;visibility : visible;left : ".$x."px;top : ".$y."px;\">\n"
	."<IMG src=\"".$fileName."?".rand()."\" width=".$size[0]." height=".$size[1]." border=\"0\"></DIV>\n");

print("</body>\n");
print("</html>\n");
