<?php

$kind = (string)$_GET['kind'];
$code = (string)$_GET['code'];
$x = (float)$_GET['x'];
$y = (float)$_GET['y'];
$minWidthDot = (float)$_GET['minWidthDot'];
$height = (float)$_GET['height'];
$dispStartStopCode = (bool)$_GET['dispStartStopCode'];
$rotateAngle = (int)$_GET['rotateAngle'];

require_once("barcode.php/Code39.php");
require_once("barcode.php/Code128.php");
require_once("barcode.php/EAN128.php");
require_once("barcode.php/Jan8.php");
require_once("barcode.php/Jan13.php");
require_once("barcode.php/ITF.php");
require_once("barcode.php/Matrix2of5.php");
require_once("barcode.php/NEC2of5.php");
require_once("barcode.php/NW7.php");
require_once("barcode.php/QR.php");
require_once("barcode.php/YubinCustomer.php");
$barcode = null;
$qr = null;

switch ($kind)
{
	case "code39":
		$barcode = new Code39();
		$barcode->dispStartStopCode = $dispStartStopCode;
		break;
	case "code128":
		$barcode = new Code128();
		break;
	case "ean128":
		$barcode = new EAN128();
		break;
	case "itf":
		$barcode = new ITF();
		break;
	case "jan8":
		$barcode = new Jan8();
		break;
	case "jan13":
		$barcode = new Jan13();
		break;
	case "matrix2of5":
		$barcode = new Matrix2of5();
		break;
	case "nec2of5":
		$barcode = new NEC2of5();
		break;
	case "nw7":
		$barcode = new NW7();
		$barcode->dispStartStopCode = $dispStartStopCode;
		break;
	default :
		print("Nothing Barcode !!\n");
		break;
}



// バーコード描画 (PNGファイル)
$img = $barcode->draw($code, $minWidthDot, $height);

// 回転
if($rotateAngle != 0) {
	$img = imagerotate($img, $rotateAngle, 0);
}

$fileName = "gazou/gazou.png";
ImagePNG($img, $fileName);

$size = GetImageSize($fileName);
header("Content-Type: text/html; charset=shift_jis") ;
print("<html>\n");
print("<head>\n");
print("<title>Barcode Test Output</title>\n");
print("</head>\n");
print("<body>\n");

print("<DIV id=\"Barcode\" style=\"position : absolute;width : ".$size[0]."px;height : ".$size[1]."px;z-index : 1;visibility : visible;left : ".$x."px;top : ".$y."px;\">\n"
	."<IMG src=\"".$fileName."?".rand()."\" width=".$size[0]." height=".$size[1]." border=\"0\"></DIV>\n");

print("</body>\n");
print("</html>\n");
