<?php

$kind = (string)$_GET['kind'];
$code = (string)$_GET['code'];
$x = (float)$_GET['x'];
$y = (float)$_GET['y'];
$height = (float)$_GET['height'];
$width = (float)$_GET['width'];
if(isset($_GET['dispStartStopCode'])){
    $dispStartStopCode = (bool)$_GET['dispStartStopCode'];
}
if(isset($_GET['typeDatabar14'])){
    $typeDatabar14 = (string)$_GET['typeDatabar14'];
}
if(isset($_GET['typeDatabarExpanded'])){
    $typeDatabarEx = (string)$_GET['typeDatabarExpanded'];
}
if(isset($_GET['CodeSet128'])){
    $CodeSet128 = (string)$_GET['CodeSet128'];
}


require_once("barcode.php/Code39.php");
require_once("barcode.php/Code93.php");
require_once("barcode.php/Code128.php");
require_once("barcode.php/EAN128.php");
require_once("barcode.php/Databar14.php");
require_once("barcode.php/DatabarLimited.php");
require_once("barcode.php/DatabarExpanded.php");
require_once("barcode.php/ITF.php");
require_once("barcode.php/Jan8.php");
require_once("barcode.php/Jan13.php");
require_once("barcode.php/UpcA.php");
require_once("barcode.php/UpcE.php");
require_once("barcode.php/Matrix2of5.php");
require_once("barcode.php/NEC2of5.php");
require_once("barcode.php/NW7.php");
require_once("barcode.php/QR.php");
require_once("barcode.php/Pdf417.php");
require_once("barcode.php/YubinCustomer.php");
$barcode = null;
$qr = null;

switch ($kind)
{
	case "code39":
		$barcode = new Code39();
		break;
	case "code93":
		$barcode = new Code93();
		break;
	case "code128":
		$barcode = new Code128();
		if($CodeSet128 == "")
		{
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		elseif ($CodeSet128 == "A")
		{
			$barcode->CodeABC = CodeSet128::CODE_A;
		}
		elseif ($CodeSet128 == "B")
		{
			$barcode->CodeABC = CodeSet128::CODE_B;
		}
		elseif ($CodeSet128 == "C")
		{
			$barcode->CodeABC = CodeSet128::CODE_C;
		}
		else
		{
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		break;
	case "gs1-128":
		$barcode = new GS1_128();
		if($CodeSet128 == "")
		{
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		elseif ($CodeSet128 == "A")
		{
			$barcode->CodeABC = CodeSet128::CODE_A;
		}
		elseif ($CodeSet128 == "B")
		{
			$barcode->CodeABC = CodeSet128::CODE_B;
		}
		elseif ($CodeSet128 == "C")
		{
			$barcode->CodeABC = CodeSet128::CODE_C;
		}
		else
		{
			// 自動(最小バーコード)
			$barcode->CodeABC = CodeSet128::AUTO;
		}
		break;
	case "gs1-Databar-14":
		$barcode = new Databar14();
		if($typeDatabar14 == "Omni-directional")
		{
			// GS1 Databar (RSS) 標準型
			$barcode->symbolType = Databar14::OMNIDIRECTIONAL;
		}
		elseif ($typeDatabar14 == "Stacked")
		{
			// GS1 Databar (RSS) 二層型
			$barcode->symbolType = Databar14::STACKED;
		}
		else
		{
			// GS1 Databar (RSS) 標準二層型
			$barcode->symbolType = Databar14::STACKED_OMNIDIRECTIONAL;
		}
		break;
	case "gs1-Databar-Limited":
		// GS1 Databar (RSS) 限定型
		$barcode = new DatabarLimited();
		break;
	case "gs1-Databar-Expanded":
		$barcode = new DatabarExpanded();
		if($typeDatabarEx == "UnStacked")
		{
			// GS1 Databar (RSS) 拡張型(一層)
			$barcode->symbolType = DatabarExpanded::UNSTACKED;
		}
		else
		{
			// GS1 Databar (RSS) 拡張多層型
			$barcode->symbolType = DatabarExpanded::STACKED;
		}
		break;
	case "itf":
		$barcode = new ITF();
		break;
	case "jan13":
		$barcode = new Jan13();
		break;
	case "jan8":
		$barcode = new Jan8();
		break;
	case "UPC-A":
		$barcode = new UpcA();
		break;
	case "UPC-E":
		$barcode = new UpcE();
		break;
	case "matrix2of5":
		$barcode = new Matrix2of5();
		break;
	case "nec2of5":
		$barcode = new NEC2of5();
		break;
	case "nw7":
		$barcode = new NW7();
		break;
	case "qr":
		$qr = new QR();
		break;
	case "post":
		$barcode = new YubinCustomer();
		break;
	default :
		print("Nothing BarCode !!\n");
		break;
}

// 添え字は描画しない(後ほど自分で描画する)
$barcode->TextWrite = false;

if($kind == "gs1-128")
{
	// 例えば全体を4倍にしてバーの厚みは3にする ← バーが太すぎる時の精度を出す微調整
	$barcode->BarThick = 3;
	$img = $barcode->draw($code, 3 * 4, $height * 4);
}
else
{
	$img = $barcode->draw($code, 4, $height * 4);
}

$fileName = "gazou/gazou.png";
ImagePNG($img, $fileName);

require("fpdf/mbfpdf.php");
//$pdf = new MBFPDF();
$pdf = new MBFPDF('P', 'mm', 'A4');
$pdf->Open();
$pdf->AddPage();

// 添え字のフォント
$fontSize = 10;
$pdf->AddMBFont(GOTHIC ,'SJIS');
$pdf->SetFont(GOTHIC,'',$fontSize);

// Databar の特殊処理です。なくても動きます。
// 通常のPDF出力の例は出来上がった画像を縮小してPDFに描画しています。
// そのため、層と層の間のモジュールのサイズ比率が狂います。
// そこで、Databarの可変2層・多層は、縦横等比で出力しておきます。
// 幅基準なので高さは低くなるかもしれません。
// 入力の幅・高さを大きな値にするなど調整してお試しください。
if(($kind == "gs1-Databar-14" && $barcode->symbolType == Databar14::STACKED_OMNIDIRECTIONAL)
	|| 	($kind == "gs1-Databar-Expanded" && $barcode->symbolType == DatabarExpanded::STACKED)
)
{
	// 画像の幅・高さと、指定幅から描画高さを決定
	$imgW = imagesx($img);
	$imgH = imagesy($img);
	$height = $imgH * $width / $imgW;

	$pdf->SetXY($x, $y - 10);
	$pdf->Write(12, "Equal proportions the aspect");

}


// バーコード画像　→ PDF
$pdf->Image($fileName, $x, $y, $width, $height);


// 添え字の描画
if($kind == "code39" || $kind == "nw7")
{
	if($dispStartStopCode == true)
	{
		$code = $barcode->outputCode;
	}
}
else
{
	if($kind == "UPC-E"
		|| 	$kind == "gs1-128"
		|| 	$kind == "gs1-Databar-14"
		|| 	$kind == "gs1-Databar-Limited"
		|| 	$kind == "gs1-Databar-Expanded"
	)
	{
		$code = $barcode->outputCode;
	}
}
$interval = ($width - $fontSize) / (strlen($code) - 1);
for($i = 0; $i < strlen($code); $i++) {
	$pdf->SetXY($x + $i * $interval, $y + $height - 2);
	$pdf->Write($fontSize, substr($code, $i, 1));
}




$pdf->SetDisplayMode(100, 'single');
$pdf->Output();
